﻿using System;
using System.IO;
using System.Reflection;
using System.Text.RegularExpressions;
using ReflectionInterface;

namespace ReflectionApp {
    class Program {
        static void Main(string[] args) {
            string className = args[0];
            string _dllNameTermination = ".dll";
            string _currWorkingDir = Directory.GetCurrentDirectory();
            IMyInterfaceForReflection _objLoadedByReflection;

            Console.WriteLine("Current working directory (cwd): " + _currWorkingDir);
            foreach (string filename in Directory.EnumerateFiles(_currWorkingDir)) {
                Console.WriteLine("file in cwd: " + filename);
                if (filename.EndsWith(_dllNameTermination)) {
                    Console.WriteLine("File is a dll...Let's look at it's contained types...");
                    Assembly _dll = Assembly.LoadFrom(filename);
                    Type[] _typeList = _dll.GetTypes();
                    foreach (Type type in _typeList) {
                        Console.WriteLine("type contained in dll: " + type.Name);
                        if (type.Name == className) {
                            Console.WriteLine("Found type to load dynamically: " + className);
                            _objLoadedByReflection = (IMyInterfaceForReflection)Activator.CreateInstance(type);
                            foreach (MethodInfo method in type.GetMethods()) {
                                Console.WriteLine("method from class " + className + ": " + method.Name);
                            }
                            _objLoadedByReflection.M("success!");
                        }
                    }
                }
            }
        }
    }
}
